/*
 * THIS FILE WAS AUTOMATICALLY GENERATED, DO NOT EDIT.
 *
 * Copyright (C) 2024 Apple Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#pragma once

namespace WebKit {

struct WebPreferencesStore;

struct SharedPreferencesForWebProcess {
    uint64_t version { 0 };
    bool allowTestOnlyIPC { false };
#if ENABLE(APPLE_PAY)
    bool applePayEnabled { false };
#endif
#if ENABLE(DEVICE_ORIENTATION)
    bool deviceOrientationEventEnabled { false };
#endif
#if ENABLE(DEVICE_ORIENTATION)
    bool deviceOrientationPermissionAPIEnabled { false };
#endif
#if ENABLE(ENCRYPTED_MEDIA)
    bool encryptedMediaAPIEnabled { false };
#endif
#if ENABLE(MEDIA_CONTROLS_CONTEXT_MENUS)
    bool mediaControlsContextMenusEnabled { false };
#endif
#if USE(SYSTEM_PREVIEW)
    bool systemPreviewEnabled { false };
#endif
    bool usesSingleWebProcess { false };
#if ENABLE(FULLSCREEN_API)
    bool videoFullscreenRequiresElementFullscreen { false };
#endif
    bool videoPresentationManagerEnabled { false };
    bool videoPresentationModeAPIEnabled { false };
#if ENABLE(WEB_AUDIO)
    bool webAudioEnabled { false };
#endif
    bool webSocketEnabled { false };
    bool allowPrivacySensitiveOperationsInNonPersistentDataStores { false };
    bool appBadgeEnabled { false };
#if ENABLE(ATTACHMENT_ELEMENT)
    bool attachmentElementEnabled { false };
#endif
#if ENABLE(WEB_PUSH_NOTIFICATIONS)
    bool builtInNotificationsEnabled { false };
#endif
    bool canvasPixelFormatEnabled { false };
    bool inputTypeColorEnabled { false };
    bool contactPickerAPIEnabled { false };
    bool cookieStoreManagerEnabled { false };
    bool dataListElementEnabled { false };
    bool inputTypeDateEnabled { false };
    bool digitalCredentialsEnabled { false };
#if ENABLE(RE_DYNAMIC_CONTENT_SCALING)
    bool useCGDisplayListsForDOMRendering { false };
#endif
#if ENABLE(LEGACY_ENCRYPTED_MEDIA)
    bool legacyEncryptedMediaAPIEnabled { false };
#endif
#if ENABLE(MODEL_PROCESS)
    bool modelProcessEnabled { false };
#endif
    bool blobFileAccessEnforcementEnabled { false };
#if ENABLE(MEDIA_SESSION_COORDINATOR)
    bool mediaSessionCoordinatorEnabled { false };
#endif
    bool fileSystemWritableStreamEnabled { false };
#if ENABLE(FULLSCREEN_API)
    bool fullScreenEnabled { false };
#endif
#if ENABLE(GPU_PROCESS)
    bool useGPUProcessForDOMRenderingEnabled { false };
#endif
#if ENABLE(GPU_PROCESS)
    bool useGPUProcessForMediaEnabled { false };
#endif
#if ENABLE(GPU_PROCESS) && ENABLE(WEBGL)
    bool useGPUProcessForWebGLEnabled { false };
#endif
#if ENABLE(GAMEPAD)
    bool gamepadsEnabled { false };
#endif
    bool geolocationAPIEnabled { false };
#if ENABLE(MODEL_ELEMENT)
    bool modelElementEnabled { false };
#endif
    bool inputTypeColorEnhancementsEnabled { false };
    bool ignoreIframeEmbeddingProtectionsEnabled { false };
    bool lockdownFontParserEnabled { false };
#if ENABLE(MEDIA_SOURCE)
    bool managedMediaSourceEnabled { false };
#endif
    bool mediaPlaybackEnabled { false };
#if ENABLE(MEDIA_SESSION)
    bool mediaSessionEnabled { false };
#endif
    bool mediaSourceEnabled { false };
#if ENABLE(MEDIA_RECORDER_WEBM)
    bool mediaRecorderEnabledWebM { false };
#endif
#if ENABLE(MEDIA_RECORDER)
    bool mediaRecorderEnabled { false };
#endif
#if ENABLE(MEDIA_SOURCE) && USE(AVFOUNDATION)
    bool mediaSourceCanFallbackToDecompressionSession { false };
#endif
#if ENABLE(MEDIA_SOURCE) && USE(AVFOUNDATION)
    bool mediaSourcePrefersDecompressionSession { false };
#endif
    bool inputTypeMonthEnabled { false };
#if ENABLE(NOTIFICATION_EVENT)
    bool notificationEventEnabled { false };
#endif
#if ENABLE(NOTIFICATIONS)
    bool notificationsEnabled { false };
#endif
    bool loginStatusAPIRequiresWebAuthnEnabled { false };
    bool screenOrientationAPIEnabled { false };
    bool serviceWorkersEnabled { false };
    bool shapeDetection { false };
    bool siteIsolationEnabled { false };
    bool speechRecognitionEnabled { false };
    bool speechSynthesisAPIEnabled { false };
#if ENABLE(IMAGE_ANALYSIS) && ENABLE(VIDEO)
    bool textRecognitionInVideosEnabled { false };
#endif
    bool inputTypeTimeEnabled { false };
#if HAVE(AVCAPTUREDEVICEROTATIONCOORDINATOR)
    bool useAVCaptureDeviceRotationCoordinatorAPI { false };
#endif
#if ENABLE(WEB_AUTHN)
    bool webAuthenticationEnabled { false };
#endif
    bool webLocksAPIEnabled { false };
#if ENABLE(WEB_PAGE_SPATIAL_BACKDROP)
    bool webPageSpatialBackdropEnabled { false };
#endif
#if ENABLE(WEB_CODECS)
    bool webCodecsVideoEnabled { false };
#endif
    bool webGLEnabled { false };
    bool webGPUHDREnabled { false };
    bool webXRWebGPUBindingsEnabled { false };
    bool webGPUEnabled { false };
#if ENABLE(WEB_RTC)
    bool peerConnectionEnabled { false };
#endif
    bool webTransportEnabled { false };
#if ENABLE(WEBXR)
    bool webXREnabled { false };
#endif
    bool inputTypeWeekEnabled { false };
    bool inputTypeDateTimeLocalEnabled { false };
    bool shadowRootReferenceTargetEnabled { false };

    bool operator==(const SharedPreferencesForWebProcess&) const = default;
};

SharedPreferencesForWebProcess sharedPreferencesForWebProcess(const WebPreferencesStore&);
bool updateSharedPreferencesForWebProcess(SharedPreferencesForWebProcess&, const WebPreferencesStore&);

} // namespace WebKit
