/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEB_AUDIO)

#include "JSAutomationRate.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>
#include <wtf/SortedArrayMap.h>



namespace WebCore {
using namespace JSC;

String convertEnumerationToString(AutomationRate enumerationValue)
{
    static const std::array<NeverDestroyed<String>, 2> values {
        MAKE_STATIC_STRING_IMPL("a-rate"),
        MAKE_STATIC_STRING_IMPL("k-rate"),
    };
    static_assert(static_cast<size_t>(AutomationRate::ARate) == 0, "AutomationRate::ARate is not 0 as expected");
    static_assert(static_cast<size_t>(AutomationRate::KRate) == 1, "AutomationRate::KRate is not 1 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < std::size(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(VM& vm, AutomationRate enumerationValue)
{
    return jsStringWithCache(vm, convertEnumerationToString(enumerationValue));
}

template<> std::optional<AutomationRate> parseEnumerationFromString<AutomationRate>(const String& stringValue)
{
    static constexpr std::array<std::pair<ComparableASCIILiteral, AutomationRate>, 2> mappings {
        std::pair<ComparableASCIILiteral, AutomationRate> { "a-rate"_s, AutomationRate::ARate },
        std::pair<ComparableASCIILiteral, AutomationRate> { "k-rate"_s, AutomationRate::KRate },
    };
    static constexpr SortedArrayMap enumerationMapping { mappings };
    if (auto* enumerationValue = enumerationMapping.tryGet(stringValue); LIKELY(enumerationValue))
        return *enumerationValue;
    return std::nullopt;
}

template<> std::optional<AutomationRate> parseEnumeration<AutomationRate>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    return parseEnumerationFromString<AutomationRate>(value.toWTFString(&lexicalGlobalObject));
}

template<> ASCIILiteral expectedEnumerationValues<AutomationRate>()
{
    return "\"a-rate\", \"k-rate\""_s;
}

} // namespace WebCore


#endif // ENABLE(WEB_AUDIO)
