/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSBarcodeDetector.h"

#include "ActiveDOMObject.h"
#include "DOMPromiseProxy.h"
#include "ExtendedDOMClientIsoSubspaces.h"
#include "ExtendedDOMIsoSubspaces.h"
#include "JSBarcodeDetectorOptions.h"
#include "JSBarcodeFormat.h"
#include "JSBlob.h"
#include "JSCSSStyleImageValue.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructor.h"
#include "JSDOMConvertDictionary.h"
#include "JSDOMConvertEnumeration.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertPromise.h"
#include "JSDOMConvertSequences.h"
#include "JSDOMConvertUnion.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMGlobalObjectInlines.h"
#include "JSDOMOperation.h"
#include "JSDOMOperationReturningPromise.h"
#include "JSDOMWrapperCache.h"
#include "JSDetectedBarcode.h"
#include "JSHTMLCanvasElement.h"
#include "JSHTMLImageElement.h"
#include "JSHTMLVideoElement.h"
#include "JSImageBitmap.h"
#include "JSImageData.h"
#include "JSOffscreenCanvas.h"
#include "JSSVGImageElement.h"
#include "JSWebCodecsVideoFrame.h"
#include "ScriptExecutionContext.h"
#include "WebCoreJSClientData.h"
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSArray.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/SlotVisitorMacros.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <variant>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>
#include <wtf/text/MakeString.h>

namespace WebCore {
using namespace JSC;

// Functions

static JSC_DECLARE_HOST_FUNCTION(jsBarcodeDetectorConstructorFunction_getSupportedFormats);
static JSC_DECLARE_HOST_FUNCTION(jsBarcodeDetectorPrototypeFunction_detect);

// Attributes

static JSC_DECLARE_CUSTOM_GETTER(jsBarcodeDetectorConstructor);

class JSBarcodeDetectorPrototype final : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSBarcodeDetectorPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSBarcodeDetectorPrototype* ptr = new (NotNull, JSC::allocateCell<JSBarcodeDetectorPrototype>(vm)) JSBarcodeDetectorPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    template<typename CellType, JSC::SubspaceAccess>
    static JSC::GCClient::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSBarcodeDetectorPrototype, Base);
        return &vm.plainObjectSpace();
    }
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSBarcodeDetectorPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};
STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSBarcodeDetectorPrototype, JSBarcodeDetectorPrototype::Base);

using JSBarcodeDetectorDOMConstructor = JSDOMConstructor<JSBarcodeDetector>;

/* Hash table for constructor */

static const std::array<HashTableValue, 1> JSBarcodeDetectorConstructorTableValues {
    HashTableValue { "getSupportedFormats"_s, static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { HashTableValue::NativeFunctionType, jsBarcodeDetectorConstructorFunction_getSupportedFormats, 0 } },
};

template<> EncodedJSValue JSC_HOST_CALL_ATTRIBUTES JSBarcodeDetectorDOMConstructor::construct(JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = lexicalGlobalObject->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* castedThis = jsCast<JSBarcodeDetectorDOMConstructor*>(callFrame->jsCallee());
    ASSERT(castedThis);
    auto* context = castedThis->scriptExecutionContext();
    if (UNLIKELY(!context))
        return throwConstructorScriptExecutionContextUnavailableError(*lexicalGlobalObject, throwScope, "BarcodeDetector"_s);
    EnsureStillAliveScope argument0 = callFrame->argument(0);
    auto barcodeDetectorOptionsConversionResult = convert<IDLDictionary<BarcodeDetectorOptions>>(*lexicalGlobalObject, argument0.value());
    if (UNLIKELY(barcodeDetectorOptionsConversionResult.hasException(throwScope)))
       return encodedJSValue();
    auto object = BarcodeDetector::create(*context, barcodeDetectorOptionsConversionResult.releaseReturnValue());
    if constexpr (IsExceptionOr<decltype(object)>)
        RETURN_IF_EXCEPTION(throwScope, { });
    static_assert(TypeOrExceptionOrUnderlyingType<decltype(object)>::isRef);
    auto jsValue = toJSNewlyCreated<IDLInterface<BarcodeDetector>>(*lexicalGlobalObject, *castedThis->globalObject(), throwScope, WTFMove(object));
    if constexpr (IsExceptionOr<decltype(object)>)
        RETURN_IF_EXCEPTION(throwScope, { });
    setSubclassStructureIfNeeded<BarcodeDetector>(lexicalGlobalObject, callFrame, asObject(jsValue));
    RETURN_IF_EXCEPTION(throwScope, { });
    return JSValue::encode(jsValue);
}
JSC_ANNOTATE_HOST_FUNCTION(JSBarcodeDetectorDOMConstructorConstruct, JSBarcodeDetectorDOMConstructor::construct);

template<> const ClassInfo JSBarcodeDetectorDOMConstructor::s_info = { "BarcodeDetector"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSBarcodeDetectorDOMConstructor) };

template<> JSValue JSBarcodeDetectorDOMConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSBarcodeDetectorDOMConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    JSString* nameString = jsNontrivialString(vm, "BarcodeDetector"_s);
    m_originalName.set(vm, this, nameString);
    putDirect(vm, vm.propertyNames->name, nameString, JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->prototype, JSBarcodeDetector::prototype(vm, globalObject), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum | JSC::PropertyAttribute::DontDelete);
    reifyStaticProperties(vm, JSBarcodeDetector::info(), JSBarcodeDetectorConstructorTableValues, *this);
}

/* Hash table for prototype */

static const std::array<HashTableValue, 2> JSBarcodeDetectorPrototypeTableValues {
    HashTableValue { "constructor"_s, static_cast<unsigned>(PropertyAttribute::DontEnum), NoIntrinsic, { HashTableValue::GetterSetterType, jsBarcodeDetectorConstructor, 0 } },
    HashTableValue { "detect"_s, static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { HashTableValue::NativeFunctionType, jsBarcodeDetectorPrototypeFunction_detect, 1 } },
};

const ClassInfo JSBarcodeDetectorPrototype::s_info = { "BarcodeDetector"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSBarcodeDetectorPrototype) };

void JSBarcodeDetectorPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSBarcodeDetector::info(), JSBarcodeDetectorPrototypeTableValues, *this);
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
}

const ClassInfo JSBarcodeDetector::s_info = { "BarcodeDetector"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSBarcodeDetector) };

JSBarcodeDetector::JSBarcodeDetector(Structure* structure, JSDOMGlobalObject& globalObject, Ref<BarcodeDetector>&& impl)
    : JSDOMWrapper<BarcodeDetector>(structure, globalObject, WTFMove(impl))
{
}

static_assert(!std::is_base_of<ActiveDOMObject, BarcodeDetector>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

JSObject* JSBarcodeDetector::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    auto* structure = JSBarcodeDetectorPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype());
    structure->setMayBePrototype(true);
    return JSBarcodeDetectorPrototype::create(vm, &globalObject, structure);
}

JSObject* JSBarcodeDetector::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSBarcodeDetector>(vm, globalObject);
}

JSValue JSBarcodeDetector::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSBarcodeDetectorDOMConstructor, DOMConstructorID::BarcodeDetector>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSBarcodeDetector::destroy(JSC::JSCell* cell)
{
    JSBarcodeDetector* thisObject = static_cast<JSBarcodeDetector*>(cell);
    thisObject->JSBarcodeDetector::~JSBarcodeDetector();
}

JSC_DEFINE_CUSTOM_GETTER(jsBarcodeDetectorConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSBarcodeDetectorPrototype*>(JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(lexicalGlobalObject, throwScope);
    return JSValue::encode(JSBarcodeDetector::getConstructor(vm, prototype->globalObject()));
}

static inline JSC::EncodedJSValue jsBarcodeDetectorConstructorFunction_getSupportedFormatsBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, Ref<DeferredPromise>&& promise)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    auto* context = jsCast<JSDOMGlobalObject*>(lexicalGlobalObject)->scriptExecutionContext();
    if (UNLIKELY(!context))
        return JSValue::encode(jsUndefined());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLPromise<IDLSequence<IDLEnumeration<BarcodeFormat>>>>(*lexicalGlobalObject, *jsCast<JSDOMGlobalObject*>(lexicalGlobalObject), throwScope, [&]() -> decltype(auto) { return BarcodeDetector::getSupportedFormats(*context, WTFMove(promise)); })));
}

JSC_DEFINE_HOST_FUNCTION(jsBarcodeDetectorConstructorFunction_getSupportedFormats, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperationReturningPromise<JSBarcodeDetector>::callStatic<jsBarcodeDetectorConstructorFunction_getSupportedFormatsBody>(*lexicalGlobalObject, *callFrame, "getSupportedFormats");
}

static inline JSC::EncodedJSValue jsBarcodeDetectorPrototypeFunction_detectBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame, typename IDLOperationReturningPromise<JSBarcodeDetector>::ClassParameter castedThis, Ref<DeferredPromise>&& promise)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    SUPPRESS_UNCOUNTED_LOCAL auto& impl = castedThis->wrapped();
    if (UNLIKELY(callFrame->argumentCount() < 1))
        return throwVMError(lexicalGlobalObject, throwScope, createNotEnoughArgumentsError(lexicalGlobalObject));
    auto* context = jsCast<JSDOMGlobalObject*>(lexicalGlobalObject)->scriptExecutionContext();
    if (UNLIKELY(!context))
        return JSValue::encode(jsUndefined());
    EnsureStillAliveScope argument0 = callFrame->uncheckedArgument(0);
    auto imageConversionResult = convert<IDLUnion<IDLInterface<HTMLImageElement>, IDLInterface<HTMLVideoElement>, IDLInterface<HTMLCanvasElement>, IDLInterface<SVGImageElement>, IDLInterface<ImageBitmap>, IDLInterface<OffscreenCanvas>, IDLInterface<CSSStyleImageValue>, IDLInterface<WebCodecsVideoFrame>, IDLInterface<Blob>, IDLInterface<ImageData>>>(*lexicalGlobalObject, argument0.value());
    if (UNLIKELY(imageConversionResult.hasException(throwScope)))
       return encodedJSValue();
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJS<IDLPromise<IDLSequence<IDLDictionary<DetectedBarcode>>>>(*lexicalGlobalObject, *castedThis->globalObject(), throwScope, [&]() -> decltype(auto) { return impl.detect(*context, imageConversionResult.releaseReturnValue(), WTFMove(promise)); })));
}

JSC_DEFINE_HOST_FUNCTION(jsBarcodeDetectorPrototypeFunction_detect, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperationReturningPromise<JSBarcodeDetector>::call<jsBarcodeDetectorPrototypeFunction_detectBody>(*lexicalGlobalObject, *callFrame, "detect");
}

JSC::GCClient::IsoSubspace* JSBarcodeDetector::subspaceForImpl(JSC::VM& vm)
{
    return WebCore::subspaceForImpl<JSBarcodeDetector, UseCustomHeapCellType::No>(vm,
        [] (auto& spaces) { return spaces.m_clientSubspaceForBarcodeDetector.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_clientSubspaceForBarcodeDetector = std::forward<decltype(space)>(space); },
        [] (auto& spaces) { return spaces.m_subspaceForBarcodeDetector.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_subspaceForBarcodeDetector = std::forward<decltype(space)>(space); }
    );
}

void JSBarcodeDetector::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSBarcodeDetector*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (RefPtr context = thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, makeString("url "_s, context->url().string()));
    Base::analyzeHeap(cell, analyzer);
}

bool JSBarcodeDetectorOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, AbstractSlotVisitor& visitor, ASCIILiteral* reason)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    UNUSED_PARAM(reason);
    return false;
}

void JSBarcodeDetectorOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsBarcodeDetector = static_cast<JSBarcodeDetector*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, jsBarcodeDetector->protectedWrapped().ptr(), jsBarcodeDetector);
}

WTF_ALLOW_UNSAFE_BUFFER_USAGE_BEGIN
#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7BarcodeDetector@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore15BarcodeDetectorE[]; }
#endif
template<typename T, typename = std::enable_if_t<std::is_same_v<T, BarcodeDetector>, void>> static inline void verifyVTable(BarcodeDetector* ptr) {
    if constexpr (std::is_polymorphic_v<T>) {
        const void* actualVTablePointer = getVTablePointer<T>(ptr);
#if PLATFORM(WIN)
        void* expectedVTablePointer = __identifier("??_7BarcodeDetector@WebCore@@6B@");
#else
        void* expectedVTablePointer = &_ZTVN7WebCore15BarcodeDetectorE[2];
#endif

        // If you hit this assertion you either have a use after free bug, or
        // BarcodeDetector has subclasses. If BarcodeDetector has subclasses that get passed
        // to toJS() we currently require BarcodeDetector you to opt out of binding hardening
        // by adding the SkipVTableValidation attribute to the interface IDL definition
        RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
    }
}
#endif
WTF_ALLOW_UNSAFE_BUFFER_USAGE_END

JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject* globalObject, Ref<BarcodeDetector>&& impl)
{
#if ENABLE(BINDING_INTEGRITY)
    verifyVTable<BarcodeDetector>(impl.ptr());
#endif
    return createWrapper<BarcodeDetector>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, BarcodeDetector& impl)
{
    return wrap(lexicalGlobalObject, globalObject, impl);
}

BarcodeDetector* JSBarcodeDetector::toWrapped(JSC::VM&, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSBarcodeDetector*>(value))
        return &wrapper->wrapped();
    return nullptr;
}

}
