/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSCSSMatrixComponentOptions.h"

#include "JSDOMConvertBoolean.h"
#include <JavaScriptCore/JSCInlines.h>



namespace WebCore {
using namespace JSC;

template<> ConversionResult<IDLDictionary<CSSMatrixComponentOptions>> convertDictionary<CSSMatrixComponentOptions>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return ConversionResultException { };
    }
    CSSMatrixComponentOptions result;
    JSValue is2DValue;
    if (isNullOrUndefined)
        is2DValue = jsUndefined();
    else {
        is2DValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "is2D"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (!is2DValue.isUndefined()) {
        auto is2DConversionResult = convert<IDLBoolean>(lexicalGlobalObject, is2DValue);
        if (UNLIKELY(is2DConversionResult.hasException(throwScope)))
            return ConversionResultException { };
        result.is2D = is2DConversionResult.releaseReturnValue();
    }
    return result;
}

} // namespace WebCore

