/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSCookieSameSite.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>
#include <wtf/SortedArrayMap.h>



namespace WebCore {
using namespace JSC;

String convertEnumerationToString(CookieSameSite enumerationValue)
{
    static const std::array<NeverDestroyed<String>, 3> values {
        MAKE_STATIC_STRING_IMPL("strict"),
        MAKE_STATIC_STRING_IMPL("lax"),
        MAKE_STATIC_STRING_IMPL("none"),
    };
    static_assert(static_cast<size_t>(CookieSameSite::Strict) == 0, "CookieSameSite::Strict is not 0 as expected");
    static_assert(static_cast<size_t>(CookieSameSite::Lax) == 1, "CookieSameSite::Lax is not 1 as expected");
    static_assert(static_cast<size_t>(CookieSameSite::None) == 2, "CookieSameSite::None is not 2 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < std::size(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(VM& vm, CookieSameSite enumerationValue)
{
    return jsStringWithCache(vm, convertEnumerationToString(enumerationValue));
}

template<> std::optional<CookieSameSite> parseEnumerationFromString<CookieSameSite>(const String& stringValue)
{
    static constexpr std::array<std::pair<ComparableASCIILiteral, CookieSameSite>, 3> mappings {
        std::pair<ComparableASCIILiteral, CookieSameSite> { "lax"_s, CookieSameSite::Lax },
        std::pair<ComparableASCIILiteral, CookieSameSite> { "none"_s, CookieSameSite::None },
        std::pair<ComparableASCIILiteral, CookieSameSite> { "strict"_s, CookieSameSite::Strict },
    };
    static constexpr SortedArrayMap enumerationMapping { mappings };
    if (auto* enumerationValue = enumerationMapping.tryGet(stringValue); LIKELY(enumerationValue))
        return *enumerationValue;
    return std::nullopt;
}

template<> std::optional<CookieSameSite> parseEnumeration<CookieSameSite>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    return parseEnumerationFromString<CookieSameSite>(value.toWTFString(&lexicalGlobalObject));
}

template<> ASCIILiteral expectedEnumerationValues<CookieSameSite>()
{
    return "\"strict\", \"lax\", \"none\""_s;
}

} // namespace WebCore

