/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSFillMode.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>
#include <wtf/SortedArrayMap.h>



namespace WebCore {
using namespace JSC;

String convertEnumerationToString(FillMode enumerationValue)
{
    static const std::array<NeverDestroyed<String>, 5> values {
        MAKE_STATIC_STRING_IMPL("none"),
        MAKE_STATIC_STRING_IMPL("forwards"),
        MAKE_STATIC_STRING_IMPL("backwards"),
        MAKE_STATIC_STRING_IMPL("both"),
        MAKE_STATIC_STRING_IMPL("auto"),
    };
    static_assert(static_cast<size_t>(FillMode::None) == 0, "FillMode::None is not 0 as expected");
    static_assert(static_cast<size_t>(FillMode::Forwards) == 1, "FillMode::Forwards is not 1 as expected");
    static_assert(static_cast<size_t>(FillMode::Backwards) == 2, "FillMode::Backwards is not 2 as expected");
    static_assert(static_cast<size_t>(FillMode::Both) == 3, "FillMode::Both is not 3 as expected");
    static_assert(static_cast<size_t>(FillMode::Auto) == 4, "FillMode::Auto is not 4 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < std::size(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(VM& vm, FillMode enumerationValue)
{
    return jsStringWithCache(vm, convertEnumerationToString(enumerationValue));
}

template<> std::optional<FillMode> parseEnumerationFromString<FillMode>(const String& stringValue)
{
    static constexpr std::array<std::pair<ComparableASCIILiteral, FillMode>, 5> mappings {
        std::pair<ComparableASCIILiteral, FillMode> { "auto"_s, FillMode::Auto },
        std::pair<ComparableASCIILiteral, FillMode> { "backwards"_s, FillMode::Backwards },
        std::pair<ComparableASCIILiteral, FillMode> { "both"_s, FillMode::Both },
        std::pair<ComparableASCIILiteral, FillMode> { "forwards"_s, FillMode::Forwards },
        std::pair<ComparableASCIILiteral, FillMode> { "none"_s, FillMode::None },
    };
    static constexpr SortedArrayMap enumerationMapping { mappings };
    if (auto* enumerationValue = enumerationMapping.tryGet(stringValue); LIKELY(enumerationValue))
        return *enumerationValue;
    return std::nullopt;
}

template<> std::optional<FillMode> parseEnumeration<FillMode>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    return parseEnumerationFromString<FillMode>(value.toWTFString(&lexicalGlobalObject));
}

template<> ASCIILiteral expectedEnumerationValues<FillMode>()
{
    return "\"none\", \"forwards\", \"backwards\", \"both\", \"auto\""_s;
}

} // namespace WebCore

