/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSFocusOptions.h"

#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertOptional.h"
#include <JavaScriptCore/JSCInlines.h>



namespace WebCore {
using namespace JSC;

template<> ConversionResult<IDLDictionary<FocusOptions>> convertDictionary<FocusOptions>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return ConversionResultException { };
    }
    FocusOptions result;
    JSValue focusVisibleValue;
    if (isNullOrUndefined)
        focusVisibleValue = jsUndefined();
    else {
        focusVisibleValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "focusVisible"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (!focusVisibleValue.isUndefined()) {
        auto focusVisibleConversionResult = convert<IDLBoolean>(lexicalGlobalObject, focusVisibleValue);
        if (UNLIKELY(focusVisibleConversionResult.hasException(throwScope)))
            return ConversionResultException { };
        result.focusVisible = focusVisibleConversionResult.releaseReturnValue();
    }
    JSValue preventScrollValue;
    if (isNullOrUndefined)
        preventScrollValue = jsUndefined();
    else {
        preventScrollValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "preventScroll"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto preventScrollConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, preventScrollValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { false }; });
    if (UNLIKELY(preventScrollConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.preventScroll = preventScrollConversionResult.releaseReturnValue();
    return result;
}

} // namespace WebCore

