/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSGPUCanvasToneMappingMode.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>
#include <wtf/SortedArrayMap.h>



namespace WebCore {
using namespace JSC;

String convertEnumerationToString(GPUCanvasToneMappingMode enumerationValue)
{
    static const std::array<NeverDestroyed<String>, 2> values {
        MAKE_STATIC_STRING_IMPL("standard"),
        MAKE_STATIC_STRING_IMPL("extended"),
    };
    static_assert(static_cast<size_t>(GPUCanvasToneMappingMode::Standard) == 0, "GPUCanvasToneMappingMode::Standard is not 0 as expected");
    static_assert(static_cast<size_t>(GPUCanvasToneMappingMode::Extended) == 1, "GPUCanvasToneMappingMode::Extended is not 1 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < std::size(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(VM& vm, GPUCanvasToneMappingMode enumerationValue)
{
    return jsStringWithCache(vm, convertEnumerationToString(enumerationValue));
}

template<> std::optional<GPUCanvasToneMappingMode> parseEnumerationFromString<GPUCanvasToneMappingMode>(const String& stringValue)
{
    static constexpr std::array<std::pair<ComparableASCIILiteral, GPUCanvasToneMappingMode>, 2> mappings {
        std::pair<ComparableASCIILiteral, GPUCanvasToneMappingMode> { "extended"_s, GPUCanvasToneMappingMode::Extended },
        std::pair<ComparableASCIILiteral, GPUCanvasToneMappingMode> { "standard"_s, GPUCanvasToneMappingMode::Standard },
    };
    static constexpr SortedArrayMap enumerationMapping { mappings };
    if (auto* enumerationValue = enumerationMapping.tryGet(stringValue); LIKELY(enumerationValue))
        return *enumerationValue;
    return std::nullopt;
}

template<> std::optional<GPUCanvasToneMappingMode> parseEnumeration<GPUCanvasToneMappingMode>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    return parseEnumerationFromString<GPUCanvasToneMappingMode>(value.toWTFString(&lexicalGlobalObject));
}

template<> ASCIILiteral expectedEnumerationValues<GPUCanvasToneMappingMode>()
{
    return "\"standard\", \"extended\""_s;
}

} // namespace WebCore

