/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSGPUTextureBindingLayout.h"

#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertEnumeration.h"
#include "JSDOMConvertOptional.h"
#include "JSGPUTextureSampleType.h"
#include "JSGPUTextureViewDimension.h"
#include <JavaScriptCore/JSCInlines.h>



namespace WebCore {
using namespace JSC;

template<> ConversionResult<IDLDictionary<GPUTextureBindingLayout>> convertDictionary<GPUTextureBindingLayout>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return ConversionResultException { };
    }
    GPUTextureBindingLayout result;
    JSValue multisampledValue;
    if (isNullOrUndefined)
        multisampledValue = jsUndefined();
    else {
        multisampledValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "multisampled"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto multisampledConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, multisampledValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { false }; });
    if (UNLIKELY(multisampledConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.multisampled = multisampledConversionResult.releaseReturnValue();
    JSValue sampleTypeValue;
    if (isNullOrUndefined)
        sampleTypeValue = jsUndefined();
    else {
        sampleTypeValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "sampleType"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto sampleTypeConversionResult = convertOptionalWithDefault<IDLEnumeration<GPUTextureSampleType>>(lexicalGlobalObject, sampleTypeValue, [&]() -> ConversionResult<IDLEnumeration<GPUTextureSampleType>> { return Converter<IDLEnumeration<GPUTextureSampleType>>::ReturnType { GPUTextureSampleType::Float }; });
    if (UNLIKELY(sampleTypeConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.sampleType = sampleTypeConversionResult.releaseReturnValue();
    JSValue viewDimensionValue;
    if (isNullOrUndefined)
        viewDimensionValue = jsUndefined();
    else {
        viewDimensionValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "viewDimension"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto viewDimensionConversionResult = convertOptionalWithDefault<IDLEnumeration<GPUTextureViewDimension>>(lexicalGlobalObject, viewDimensionValue, [&]() -> ConversionResult<IDLEnumeration<GPUTextureViewDimension>> { return Converter<IDLEnumeration<GPUTextureViewDimension>>::ReturnType { GPUTextureViewDimension::_2d }; });
    if (UNLIKELY(viewDimensionConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.viewDimension = viewDimensionConversionResult.releaseReturnValue();
    return result;
}

} // namespace WebCore

