/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSMobileDocumentRequest.h"

#include "JSDOMConvertStrings.h"
#include <JavaScriptCore/JSCInlines.h>



namespace WebCore {
using namespace JSC;

template<> ConversionResult<IDLDictionary<MobileDocumentRequest>> convertDictionary<MobileDocumentRequest>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return ConversionResultException { };
    }
    MobileDocumentRequest result;
    JSValue deviceRequestValue;
    if (isNullOrUndefined)
        deviceRequestValue = jsUndefined();
    else {
        deviceRequestValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "deviceRequest"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (deviceRequestValue.isUndefined()) {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "deviceRequest"_s, "MobileDocumentRequest"_s, "DOMString"_s);
        return ConversionResultException { };
    }
    auto deviceRequestConversionResult = convert<IDLDOMString>(lexicalGlobalObject, deviceRequestValue);
    if (UNLIKELY(deviceRequestConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.deviceRequest = deviceRequestConversionResult.releaseReturnValue();
    JSValue encryptionInfoValue;
    if (isNullOrUndefined)
        encryptionInfoValue = jsUndefined();
    else {
        encryptionInfoValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "encryptionInfo"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (encryptionInfoValue.isUndefined()) {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "encryptionInfo"_s, "MobileDocumentRequest"_s, "DOMString"_s);
        return ConversionResultException { };
    }
    auto encryptionInfoConversionResult = convert<IDLDOMString>(lexicalGlobalObject, encryptionInfoValue);
    if (UNLIKELY(encryptionInfoConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.encryptionInfo = encryptionInfoConversionResult.releaseReturnValue();
    return result;
}

} // namespace WebCore

