/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSServiceWorkerClientType.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>
#include <wtf/SortedArrayMap.h>



namespace WebCore {
using namespace JSC;

String convertEnumerationToString(ServiceWorkerClientType enumerationValue)
{
    static const std::array<NeverDestroyed<String>, 4> values {
        MAKE_STATIC_STRING_IMPL("window"),
        MAKE_STATIC_STRING_IMPL("worker"),
        MAKE_STATIC_STRING_IMPL("sharedworker"),
        MAKE_STATIC_STRING_IMPL("all"),
    };
    static_assert(static_cast<size_t>(ServiceWorkerClientType::Window) == 0, "ServiceWorkerClientType::Window is not 0 as expected");
    static_assert(static_cast<size_t>(ServiceWorkerClientType::Worker) == 1, "ServiceWorkerClientType::Worker is not 1 as expected");
    static_assert(static_cast<size_t>(ServiceWorkerClientType::Sharedworker) == 2, "ServiceWorkerClientType::Sharedworker is not 2 as expected");
    static_assert(static_cast<size_t>(ServiceWorkerClientType::All) == 3, "ServiceWorkerClientType::All is not 3 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < std::size(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(VM& vm, ServiceWorkerClientType enumerationValue)
{
    return jsStringWithCache(vm, convertEnumerationToString(enumerationValue));
}

template<> std::optional<ServiceWorkerClientType> parseEnumerationFromString<ServiceWorkerClientType>(const String& stringValue)
{
    static constexpr std::array<std::pair<ComparableASCIILiteral, ServiceWorkerClientType>, 4> mappings {
        std::pair<ComparableASCIILiteral, ServiceWorkerClientType> { "all"_s, ServiceWorkerClientType::All },
        std::pair<ComparableASCIILiteral, ServiceWorkerClientType> { "sharedworker"_s, ServiceWorkerClientType::Sharedworker },
        std::pair<ComparableASCIILiteral, ServiceWorkerClientType> { "window"_s, ServiceWorkerClientType::Window },
        std::pair<ComparableASCIILiteral, ServiceWorkerClientType> { "worker"_s, ServiceWorkerClientType::Worker },
    };
    static constexpr SortedArrayMap enumerationMapping { mappings };
    if (auto* enumerationValue = enumerationMapping.tryGet(stringValue); LIKELY(enumerationValue))
        return *enumerationValue;
    return std::nullopt;
}

template<> std::optional<ServiceWorkerClientType> parseEnumeration<ServiceWorkerClientType>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    return parseEnumerationFromString<ServiceWorkerClientType>(value.toWTFString(&lexicalGlobalObject));
}

template<> ASCIILiteral expectedEnumerationValues<ServiceWorkerClientType>()
{
    return "\"window\", \"worker\", \"sharedworker\", \"all\""_s;
}

} // namespace WebCore

