/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEBGL)

#include "JSWebGLTimerQueryEXT.h"

#include "ActiveDOMObject.h"
#include "ExtendedDOMClientIsoSubspaces.h"
#include "ExtendedDOMIsoSubspaces.h"
#include "JSDOMBinding.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMWrapperCache.h"
#include "ScriptExecutionContext.h"
#include "WebCoreJSClientData.h"
#include "WebCoreOpaqueRootInlines.h"
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/SlotVisitorMacros.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>
#include <wtf/text/MakeString.h>

namespace WebCore {
using namespace JSC;

class JSWebGLTimerQueryEXTPrototype final : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSWebGLTimerQueryEXTPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSWebGLTimerQueryEXTPrototype* ptr = new (NotNull, JSC::allocateCell<JSWebGLTimerQueryEXTPrototype>(vm)) JSWebGLTimerQueryEXTPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    template<typename CellType, JSC::SubspaceAccess>
    static JSC::GCClient::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSWebGLTimerQueryEXTPrototype, Base);
        return &vm.plainObjectSpace();
    }
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSWebGLTimerQueryEXTPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};
STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSWebGLTimerQueryEXTPrototype, JSWebGLTimerQueryEXTPrototype::Base);

/* Hash table for prototype */
const ClassInfo JSWebGLTimerQueryEXTPrototype::s_info = { "WebGLTimerQueryEXT"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebGLTimerQueryEXTPrototype) };

void JSWebGLTimerQueryEXTPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
}

const ClassInfo JSWebGLTimerQueryEXT::s_info = { "WebGLTimerQueryEXT"_s, &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSWebGLTimerQueryEXT) };

JSWebGLTimerQueryEXT::JSWebGLTimerQueryEXT(Structure* structure, JSDOMGlobalObject& globalObject, Ref<WebGLTimerQueryEXT>&& impl)
    : JSDOMWrapper<WebGLTimerQueryEXT>(structure, globalObject, WTFMove(impl))
{
}

static_assert(!std::is_base_of<ActiveDOMObject, WebGLTimerQueryEXT>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

JSObject* JSWebGLTimerQueryEXT::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    auto* structure = JSWebGLTimerQueryEXTPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype());
    structure->setMayBePrototype(true);
    return JSWebGLTimerQueryEXTPrototype::create(vm, &globalObject, structure);
}

JSObject* JSWebGLTimerQueryEXT::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSWebGLTimerQueryEXT>(vm, globalObject);
}

void JSWebGLTimerQueryEXT::destroy(JSC::JSCell* cell)
{
    JSWebGLTimerQueryEXT* thisObject = static_cast<JSWebGLTimerQueryEXT*>(cell);
    thisObject->JSWebGLTimerQueryEXT::~JSWebGLTimerQueryEXT();
}

JSC::GCClient::IsoSubspace* JSWebGLTimerQueryEXT::subspaceForImpl(JSC::VM& vm)
{
    return WebCore::subspaceForImpl<JSWebGLTimerQueryEXT, UseCustomHeapCellType::No>(vm,
        [] (auto& spaces) { return spaces.m_clientSubspaceForWebGLTimerQueryEXT.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_clientSubspaceForWebGLTimerQueryEXT = std::forward<decltype(space)>(space); },
        [] (auto& spaces) { return spaces.m_subspaceForWebGLTimerQueryEXT.get(); },
        [] (auto& spaces, auto&& space) { spaces.m_subspaceForWebGLTimerQueryEXT = std::forward<decltype(space)>(space); }
    );
}

void JSWebGLTimerQueryEXT::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSWebGLTimerQueryEXT*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (RefPtr context = thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, makeString("url "_s, context->url().string()));
    Base::analyzeHeap(cell, analyzer);
}

bool JSWebGLTimerQueryEXTOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, AbstractSlotVisitor& visitor, ASCIILiteral* reason)
{
    auto* jsWebGLTimerQueryEXT = jsCast<JSWebGLTimerQueryEXT*>(handle.slot()->asCell());
    WebGLTimerQueryEXT* owner = &jsWebGLTimerQueryEXT->wrapped();
    if (UNLIKELY(reason))
        *reason = "Reachable from WebGLTimerQueryEXT"_s;
    return containsWebCoreOpaqueRoot(visitor, owner);
}

void JSWebGLTimerQueryEXTOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsWebGLTimerQueryEXT = static_cast<JSWebGLTimerQueryEXT*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, jsWebGLTimerQueryEXT->protectedWrapped().ptr(), jsWebGLTimerQueryEXT);
}

WTF_ALLOW_UNSAFE_BUFFER_USAGE_BEGIN
#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7WebGLTimerQueryEXT@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore18WebGLTimerQueryEXTE[]; }
#endif
template<typename T, typename = std::enable_if_t<std::is_same_v<T, WebGLTimerQueryEXT>, void>> static inline void verifyVTable(WebGLTimerQueryEXT* ptr) {
    if constexpr (std::is_polymorphic_v<T>) {
        const void* actualVTablePointer = getVTablePointer<T>(ptr);
#if PLATFORM(WIN)
        void* expectedVTablePointer = __identifier("??_7WebGLTimerQueryEXT@WebCore@@6B@");
#else
        void* expectedVTablePointer = &_ZTVN7WebCore18WebGLTimerQueryEXTE[2];
#endif

        // If you hit this assertion you either have a use after free bug, or
        // WebGLTimerQueryEXT has subclasses. If WebGLTimerQueryEXT has subclasses that get passed
        // to toJS() we currently require WebGLTimerQueryEXT you to opt out of binding hardening
        // by adding the SkipVTableValidation attribute to the interface IDL definition
        RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
    }
}
#endif
WTF_ALLOW_UNSAFE_BUFFER_USAGE_END

JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject* globalObject, Ref<WebGLTimerQueryEXT>&& impl)
{
#if ENABLE(BINDING_INTEGRITY)
    verifyVTable<WebGLTimerQueryEXT>(impl.ptr());
#endif
    return createWrapper<WebGLTimerQueryEXT>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, WebGLTimerQueryEXT& impl)
{
    return wrap(lexicalGlobalObject, globalObject, impl);
}

WebGLTimerQueryEXT* JSWebGLTimerQueryEXT::toWrapped(JSC::VM&, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSWebGLTimerQueryEXT*>(value))
        return &wrapper->wrapped();
    return nullptr;
}

}

#endif // ENABLE(WEBGL)
