/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSWebTransportCongestionControl.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>
#include <wtf/SortedArrayMap.h>



namespace WebCore {
using namespace JSC;

String convertEnumerationToString(WebTransportCongestionControl enumerationValue)
{
    static const std::array<NeverDestroyed<String>, 3> values {
        MAKE_STATIC_STRING_IMPL("default"),
        MAKE_STATIC_STRING_IMPL("throughput"),
        MAKE_STATIC_STRING_IMPL("low-latency"),
    };
    static_assert(static_cast<size_t>(WebTransportCongestionControl::Default) == 0, "WebTransportCongestionControl::Default is not 0 as expected");
    static_assert(static_cast<size_t>(WebTransportCongestionControl::Throughput) == 1, "WebTransportCongestionControl::Throughput is not 1 as expected");
    static_assert(static_cast<size_t>(WebTransportCongestionControl::LowLatency) == 2, "WebTransportCongestionControl::LowLatency is not 2 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < std::size(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(VM& vm, WebTransportCongestionControl enumerationValue)
{
    return jsStringWithCache(vm, convertEnumerationToString(enumerationValue));
}

template<> std::optional<WebTransportCongestionControl> parseEnumerationFromString<WebTransportCongestionControl>(const String& stringValue)
{
    static constexpr std::array<std::pair<ComparableASCIILiteral, WebTransportCongestionControl>, 3> mappings {
        std::pair<ComparableASCIILiteral, WebTransportCongestionControl> { "default"_s, WebTransportCongestionControl::Default },
        std::pair<ComparableASCIILiteral, WebTransportCongestionControl> { "low-latency"_s, WebTransportCongestionControl::LowLatency },
        std::pair<ComparableASCIILiteral, WebTransportCongestionControl> { "throughput"_s, WebTransportCongestionControl::Throughput },
    };
    static constexpr SortedArrayMap enumerationMapping { mappings };
    if (auto* enumerationValue = enumerationMapping.tryGet(stringValue); LIKELY(enumerationValue))
        return *enumerationValue;
    return std::nullopt;
}

template<> std::optional<WebTransportCongestionControl> parseEnumeration<WebTransportCongestionControl>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    return parseEnumerationFromString<WebTransportCongestionControl>(value.toWTFString(&lexicalGlobalObject));
}

template<> ASCIILiteral expectedEnumerationValues<WebTransportCongestionControl>()
{
    return "\"default\", \"throughput\", \"low-latency\""_s;
}

} // namespace WebCore

