/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSWebTransportHash.h"

#include "JSDOMConvertBufferSource.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMConvertUnion.h"
#include <JavaScriptCore/JSCInlines.h>
#include <variant>



namespace WebCore {
using namespace JSC;

template<> ConversionResult<IDLDictionary<WebTransportHash>> convertDictionary<WebTransportHash>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return ConversionResultException { };
    }
    WebTransportHash result;
    JSValue algorithmValue;
    if (isNullOrUndefined)
        algorithmValue = jsUndefined();
    else {
        algorithmValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "algorithm"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (!algorithmValue.isUndefined()) {
        auto algorithmConversionResult = convert<IDLDOMString>(lexicalGlobalObject, algorithmValue);
        if (UNLIKELY(algorithmConversionResult.hasException(throwScope)))
            return ConversionResultException { };
        result.algorithm = algorithmConversionResult.releaseReturnValue();
    }
    JSValue valueValue;
    if (isNullOrUndefined)
        valueValue = jsUndefined();
    else {
        valueValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "value"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (!valueValue.isUndefined()) {
        auto valueConversionResult = convert<IDLUnion<IDLArrayBufferView, IDLArrayBuffer>>(lexicalGlobalObject, valueValue);
        if (UNLIKELY(valueConversionResult.hasException(throwScope)))
            return ConversionResultException { };
        result.value = valueConversionResult.releaseReturnValue();
    }
    return result;
}

} // namespace WebCore

